=== Modules/Filtering/ImageCompare/CMakeLists.txt ===
project(ITKImageCompare)
itk_module_impl()
