=== debian/changelog ===
insighttoolkit5 (5.3.0-7build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:30:09 +0000

insighttoolkit5 (5.3.0-7build3) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 17:57:46 +0000

insighttoolkit5 (5.3.0-7build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:57:06 +0000

insighttoolkit5 (5.3.0-7build1) noble; urgency=medium

  * Rebuild against 'new gdcm 3.0.22-2'.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Dec 2023 13:13:16 +0100

insighttoolkit5 (5.3.0-7) unstable; urgency=medium

  * d/clean: new: remove Insight5.3Valgrind.supp. (Closes: #1047043)

 -- Étienne Mollier <emollier@debian.org>  Mon, 04 Dec 2023 22:07:07 +0100

insighttoolkit5 (5.3.0-6) unstable; urgency=medium

  [ Steve Robbins ]
  * [d47841b] Use full ::itk namespace in itkMacro.  Applied upstream patch
    identified by Flavien Bridault.  (Closes: #1052223)

 -- Steve M. Robbins <smr@debian.org>  Sun, 24 Sep 2023 23:55:49 -0500

insighttoolkit5 (5.3.0-5) unstable; urgency=medium

  [ Andreas Tille ]
  * Standards-Version: 4.6.2

  [ Steve Robbins ]
  * [17e6c01] Fix GCC-13 build.  Closes: #1037697

 -- Steve M. Robbins <smr@debian.org>  Thu, 06 Jul 2023 22:39:53 -0500

insighttoolkit5 (5.3.0-4) unstable; urgency=medium

  [ Steve Robbins ]
  * [5fac045] Add VTK dependencies to -dev package.  Closes: #1039528.

 -- Steve M. Robbins <smr@debian.org>  Tue, 27 Jun 2023 10:45:10 -0500

insighttoolkit5 (5.3.0-3) unstable; urgency=medium

  [ Steve Robbins ]
  * [3447940] Using VTK also requires qtbase5-dev, libvtk9-qt-dev.
  * [7ba4b87] Exclude tests that require display.

 -- Steve M. Robbins <smr@debian.org>  Mon, 26 Jun 2023 02:03:18 -0500

insighttoolkit5 (5.3.0-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [984ce6f] Enable Module_ITKVtkGlue.  Closes #1025504.

 -- Steve M. Robbins <smr@debian.org>  Wed, 21 Jun 2023 23:20:43 -0500

insighttoolkit5 (5.3.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [b2132ae] New upstream version 5.3.0
  * [067bb48] Update rules, control.in, and control.
  * [c1528f1] Rebase patch set.
  * [e1191ca] Update rules to avoid running expensive tests.
  * [1035950] Update install patterns: build now puts shared libs and cmake files in lib/{triplet} subdir.
  * [29e8b6b] Remove obsolete NEWS.
  * [c684693] Updates to placate lintian.
  * [d3d79fb] Remove data/watch.

 -- Steve M. Robbins <smr@debian.org>  Mon, 19 Jun 2023 00:32:38 -0500

insighttoolkit5 (5.2.1-5) unstable; urgency=medium

  * d/control: apply Multi-Arch: foreign to insighttoolkit5-examples.
    Thanks to Multiarch hinter
  * d/control: declare conformance to standards version 4.6.1.
  * d/copyright: specify which BSD variant is used by HDF5 module.

 -- Étienne Mollier <emollier@debian.org>  Wed, 18 May 2022 22:54:03 +0200

insighttoolkit5 (5.2.1-4) unstable; urgency=medium

  [ Andreas Tille ]
  * Forwarded issue upstream

  [ Étienne Mollier ]
  * d/rules: build with ITKReview module support
  * d/control: add myself to uploaders
  * d/changelog: removed reference to unreleased insighttoolkit4 version
    4.13.3withdata-dfsg1-5 and moved "Add NOTICE file to docs" entry to
    version 5.2.1-1.

 -- Étienne Mollier <emollier@debian.org>  Thu, 28 Apr 2022 00:11:58 +0200
